#include <stdio.h>
#include <map>

using namespace std;
int main() {
    int n;
    scanf("%i", &n);
    int matrica[n+1][4];
    map<int, int> ab;
    int O, A, B, AB;
    scanf("%i", &O);
    scanf("%i", &A);
    scanf("%i", &B);
    scanf("%i", &AB);
    for (int i = 0; i < n; i++) {
        matrica[i][0] = 0;
        matrica[i][1] = 0;
        matrica[i][2] = 0;
        matrica[i][3] = 0;
        char grupa[3];
        scanf("%2s", grupa);
        int broj;
        scanf("%i", &broj);
        if (grupa[0] == 'A' && grupa[1] == 'B') {

            if (broj > AB) {
                matrica[i][3] = AB;
                broj-=AB;
                AB = 0;
            } else {
                matrica[i][3] = broj;
                AB-=broj;
                continue;
            }
            ab[i] = broj;
            continue;
        }
        if (grupa[0] == 'A') {
            if (broj > A) {
                matrica[i][1] = A;
                broj-=A;
                A = 0;
            } else {
                matrica[i][1] = broj;
                A-=broj;
                continue;
            }
        }
        if (grupa[0] == 'B') {
            if (broj > B) {
                matrica[i][2] = B;
                broj-=B;
                B = 0;
            } else {
                matrica[i][2] = broj;
                B-=broj;
                continue;
            }
        }
        if (broj > O) {
            printf("nemoguce");
            return 0;
        }
        matrica[i][0] = broj;
        O-=broj;
    }
    for (int i = 0; i < ab.size(); i++) {
        int broj = ab[i];
        if (broj > A) {
            matrica[i][1] = A;
            broj-=A;
            A = 0;
        } else {
            matrica[i][1] = broj;
            A-=broj;
            continue;
        }
        if (broj > B) {
            matrica[i][2] = B;
            broj-=B;
            B = 0;
        } else {
            matrica[i][2] = broj;
            B-=broj;
            continue;
        }
        if (broj > O) {
            printf("nemoguce");
            return 0;
        }
        matrica[i][0] = broj;
        O-=broj;
    }
    printf("moguce\n");
    for (int i = 0; i < n; i++)
        printf("%i %i %i %i\n", matrica[i][0], matrica[i][1], matrica[i][2], matrica[i][3]);
    return 0;
}